// Black-Scholes price of calls and puts

double BlackScholes(double S, double K, double r, double q, double v, double T, char PutCall) {
	// S = Spot
	// K = Strike
	// r = Risk free rate
	// q = Dividend yield
	// v = Volatility
	// T = Maturity in years
	double d1 = (log(S/K) + (r-q+v*v/2)*T)/v/sqrt(T);
	double d2 = d1 - v*sqrt(T);
	double BScall = S*exp(-q*T)*N(d1) - K*exp(-r*T)*N(d2);
	double BSput  = BScall - exp(-q*T)*S + exp(-r*T)*K;
//	cout << "Nd1 " << Ni(d1) << endl;
//	cout << "Nd2 " << Ni(d2) << endl;
	if (PutCall=='C')
		return BScall;
	else
		return BSput;
}


