// GARCH log-likelihood
#include <fstream>
#include "math.h"

double GARCH_LL(vector<double> B, vector<double> ret, double S, double rf) {
	double pi = 3.14159265358979323846264338;   // pi
	int N = 6;									// Number of GARCH parameters
	int M = ret.size();

	vector<double> e(M, 0.0);
	vector<double> h(M, 0.0);
	vector<double> LL(M, 0.0);
	e[0] = 0.0;
	h[0] = 0.24;
	LL[0] = -0.5*e[0]*e[0]/h[0] - 0.5*log(2*pi*h[0]);

	double Sum = 0.0;
	if  ((abs(B[0])<0.0) || (B[1]<0.0) || (B[2]<0.0) || (B[3]<0.0))
		return 1e100;
	else {
	for (int t=1; t<=M-1; t++) {
			h[t] = B[0] + B[1]* pow(e[t-1] - B[2]*sqrt(h[t-1]), 2) + B[3]*h[t-1];
			e[t] = ret[t] - rf + 0.5*h[t];
			LL[t] = -0.5*e[t]*e[t]/h[t] - 0.5*log(2*pi*h[t]);
			Sum +=  LL[t];
		}
	return -Sum;
	}
}
